LVBMStatusBars_DragFrameFunctions = { --we need these functions because we have to re-create the drag frame dynamically when we want to change the design
	["OnLoad"] = function(frame) --omg if we call OnLoad by using GetScript("OnLoad"), this does not contain the frame...WTF
		frame.isMoving = false;
		frame.elapsed = 0;
		frame.timer = 20;
		frame:RegisterEvent("PLAYER_ENTERING_WORLD");
		getglobal(frame:GetName().."Bar"):SetMinMaxValues(0, 20);
		getglobal(frame:GetName().."BarText"):SetText("Drag me!");
		getglobal(frame:GetName().."BarTimer"):SetText(LVBM.SecondsToTime(this.timer));
		frame:SetBackdropColor(0, 0, 0, 0);
		frame:SetBackdropBorderColor(0.5, 0.5, 0.5, 0.8);
	end,
	["OnUpdate"] = function()
		this.elapsed = this.elapsed + arg1;
		if this.elapsed >= this.timer then
			this.elapsed = 0;
			this.timer = 20;
			this:Hide();
			getglobal(this:GetName().."BarTimer"):SetText(LVBM.SecondsToTime(this.timer));					
		else
			getglobal(this:GetName().."BarTimer"):SetText(LVBM.SecondsToTime(this.timer - this.elapsed));
			
			if LVBM.Options.FillUpStatusBars then
				getglobal(this:GetName().."Bar"):SetValue(this.elapsed);
			else
				getglobal(this:GetName().."Bar"):SetValue(this.timer - this.elapsed);
			end
		end				
		
		if LVBM_StatusBarTimer1 and LVBM_StatusBarTimer1:IsShown() then
			LVBM_StatusBarTimer1:SetAlpha(0);
		end
		
		local minValue, maxValue;
		minValue, maxValue = getglobal(this:GetName().."Bar"):GetMinMaxValues();				
		getglobal(this:GetName().."BarSpark"):SetPoint("CENTER", getglobal(this:GetName().."Bar"), "LEFT", ((getglobal(this:GetName().."Bar"):GetValue() / maxValue) * getglobal(this:GetName().."Bar"):GetWidth()), LVBMStatusBars_Designs[LVBM.Options.StatusBarDesign].sparkOffset);
	end,	
	["OnHide"] = function()
		if this.isMoving then
			LVBM_StatusBarTimerAnchor:StopMovingOrSizing();
			this.isMoving = false;
		end
		this.elapsed = 0;
		this.timer = 20;
		getglobal(this:GetName().."BarTimer"):SetText(LVBM.SecondsToTime(this.timer));
		if LVBM_StatusBarTimer1 then
			LVBM_StatusBarTimer1:SetAlpha(1);
		end
	end,
	["OnEvent"] = function()
		if event == "PLAYER_ENTERING_WORLD" then
			this:SetUserPlaced(nil);
			this:ClearAllPoints();
			this:SetPoint("CENTER", "LVBM_StatusBarTimerAnchor", "CENTER");
		end
	end,
	["OnMouseUp"] = function()
		if this.isMoving then
			LVBM_StatusBarTimerAnchor:StopMovingOrSizing();
			this.isMoving = false;
		end
		if arg1 == "RightButton" then
			this:Hide();
		end
	end,	
	["OnMouseDown"] = function()
		if arg1 == "LeftButton" then
			LVBM_StatusBarTimerAnchor:StartMoving();
			this.isMoving = true;
		end
	end,
	["OnEnter"] = function()
	end,
	["OnLeave"] = function()
	end,
};

LVBMStatusBars_Designs = {
	[1] = {
		["template"] = "LVBM_StatusBarTimerDefaultTemplate",
		["widthModifier"] = 8,
		["textWidthModifier"] = 59,
		["distance"] = 3,
		["sparkOffset"] = 0,
		["color"] = {
			["r"] = 1.0,
			["g"] = 0.7,
			["b"] = 0.0,
			["a"] = 1.0,
		},
		["width"] = 195,
		["scale"] = 1,
		["subFrameNames"] = {
			"Bar", "BarText", "BarTimer", "BarSpark", "BarBackground", "BarBar"
		},
		["initialize"] = function(frame)
			getglobal(frame:GetName().."BarSpark"):SetVertexColor(1, 1, 1, 1);
		end
	},
	[2] = {
		["template"] = "LVBM_StatusBarTimerExtraTemplate1",
		["widthModifier"] = 8,
		["textWidthModifier"] = 59,
		["distance"] = 1,
		["sparkOffset"] = -2,
		["color"] = {
			["r"] = 0.0,
			["g"] = 0.5,
			["b"] = 1.0,
			["a"] = 0.8,
		},
		["width"] = 265,
		["scale"] = 0.85,
		["subFrameNames"] = {
			"Bar", "BarText", "BarTimer", "BarSpark", "BarBackground", "BarBar"
		},
		["initialize"] = function(frame)
			getglobal(frame:GetName().."BarSpark"):SetVertexColor(LVBM.Options.StatusBarColor.r, LVBM.Options.StatusBarColor.g, LVBM.Options.StatusBarColor.b, LVBM.Options.StatusBarColor.a);			
		end
	},	
};

function LVBMStatusBars_OnUpdate(elapsed)
	if this.isUsed and LVBM.StatusBarData[this.usedBy] then
		LVBM.StatusBarData[this.usedBy].elapsed = LVBM.StatusBarData[this.usedBy].elapsed + elapsed;
		if LVBM.Options.FillUpStatusBars then
			getglobal(this:GetName().."Bar"):SetValue(LVBM.StatusBarData[this.usedBy].elapsed);
		else
			getglobal(this:GetName().."Bar"):SetValue(LVBM.StatusBarData[this.usedBy].timer - LVBM.StatusBarData[this.usedBy].elapsed);
		end
		getglobal(this:GetName().."BarTimer"):SetText(LVBM.SecondsToTime(LVBM.StatusBarData[this.usedBy].timer - LVBM.StatusBarData[this.usedBy].elapsed));
		if LVBM.StatusBarData[this.usedBy].elapsed >= LVBM.StatusBarData[this.usedBy].timer then
			if GameTooltip:IsShown() and GameTooltipTextLeft1 and GameTooltipTextLeft1:GetText() == getglobal(this:GetName().."BarText"):GetText() and ((not LVBM.StatusBarData[this.usedBy].repetitions) or LVBM.StatusBarData[this.usedBy].repetitions <= 1) then
				GameTooltip:Hide();
			end
			LVBM.EndStatusBarTimer(this.usedBy, true);
		end
	
		local minValue, maxValue;
		minValue, maxValue = getglobal(this:GetName().."Bar"):GetMinMaxValues();
		getglobal(this:GetName().."BarSpark"):ClearAllPoints();
		getglobal(this:GetName().."BarSpark"):SetPoint("CENTER", (this:GetName().."Bar"), "LEFT", (((getglobal(this:GetName().."Bar"):GetValue() - elapsed) / maxValue) * getglobal(this:GetName().."Bar"):GetWidth()), LVBMStatusBars_Designs[LVBM.Options.StatusBarDesign].sparkOffset);
		
		if GameTooltip:IsShown() and GameTooltipTextLeft1 and GameTooltipTextLeft1:GetText() == getglobal(this:GetName().."BarText"):GetText() then
			if GameTooltipTextRight2 then
				GameTooltipTextRight2:SetText(LVBM.SecondsToTime(LVBM.StatusBarData[this.usedBy].timer - LVBM.StatusBarData[this.usedBy].elapsed));
			end
			if GameTooltipTextRight3 then
				GameTooltipTextRight3:SetText(LVBM.SecondsToTime(LVBM.StatusBarData[this.usedBy].elapsed));
			end
			if GameTooltipTextLeft5 and GameTooltipTextRight5 and GameTooltipTextLeft5:GetText() == LVBM_SBT_REPETITIONS then
				if not LVBM.StatusBarData[this.usedBy].infinite then
					GameTooltipTextRight5:SetText(LVBM.StatusBarData[this.usedBy].repetitions);
				end
			end
		end
	end
end

function LVBMStatusBars_OnEnter()
	GameTooltip:Hide();
	GameTooltip:ClearLines();
	GameTooltip_SetDefaultAnchor(GameTooltip, UIParent);
	GameTooltip:SetText(getglobal(this:GetName().."BarText"):GetText());
	GameTooltip:AddDoubleLine(LVBM_SBT_TIMELEFT, LVBM.SecondsToTime(LVBM.StatusBarData[this.usedBy].timer - LVBM.StatusBarData[this.usedBy].elapsed), NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
	GameTooltip:AddDoubleLine(LVBM_SBT_TIMEELAPSED, LVBM.SecondsToTime(LVBM.StatusBarData[this.usedBy].elapsed), NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
	GameTooltip:AddDoubleLine(LVBM_SBT_TOTALTIME, LVBM.SecondsToTime(LVBM.StatusBarData[this.usedBy].timer), NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
	if LVBM.StatusBarData[this.usedBy].isRepeating and LVBM.StatusBarData[this.usedBy].repetitions then
		if LVBM.StatusBarData[this.usedBy].infinite then
			GameTooltip:AddDoubleLine(LVBM_SBT_REPETITIONS, LVBM_SBT_INFINITE, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		else
			GameTooltip:AddDoubleLine(LVBM_SBT_REPETITIONS, LVBM.StatusBarData[this.usedBy].repetitions, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		end
	end
	if LVBM.StatusBarData[this.usedBy].startedBy and LVBM.StatusBarData[this.usedBy].startedBy ~= "UNKNOWN" then
		GameTooltip:AddDoubleLine(LVBM_SBT_BOSSMOD, LVBM.StatusBarData[this.usedBy].startedBy, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
	end
	if LVBM.StatusBarData[this.usedBy].syncedBy and LVBM.StatusBarData[this.usedBy].syncedBy ~= LVBM_LOCAL then	
		GameTooltip:AddDoubleLine(LVBM_SBT_STARTEDBY, LVBM.StatusBarData[this.usedBy].syncedBy, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
	else
		GameTooltip:AddDoubleLine(LVBM_SBT_STARTEDBY, UnitName("player"), NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
	end
	GameTooltip:AddLine(LVBM_SBT_LEFTCLICK, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
	GameTooltip:AddLine(LVBM_SBT_RIGHTCLICK, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
	GameTooltip:Show();
end

function LVBMStatusBars_SetDefaultValues()
	LVBM.Options.StatusBarColor = {
		["r"] = 1.0,
		["g"] = 0.7,
		["b"] = 0.0,
		["a"] = 1.0,
	};
	LVBM.Options.StatusBarsFlippedOver = false;
	LVBM.Options.FillUpStatusBars = true;
	LVBM.Options.EnableStatusBars = true;
	LVBM.Options.StatusBarSize = {
		["Scale"] = 1,
		["Width"] = 195,
	};
end

function LVBMStatusBars_FlipOver()
	if LVBM.Options.StatusBarsFlippedOver then
		for i = 2, LVBM.StatusBarCount do
			getglobal("LVBM_StatusBarTimer"..i):ClearAllPoints()
			getglobal("LVBM_StatusBarTimer"..i):SetPoint("BOTTOM", "LVBM_StatusBarTimer"..(i-1), "TOP", 0, -LVBMStatusBars_Designs[LVBM.Options.StatusBarDesign].distance);
		end
	else
		for i = 2, LVBM.StatusBarCount do
			getglobal("LVBM_StatusBarTimer"..i):ClearAllPoints()
			getglobal("LVBM_StatusBarTimer"..i):SetPoint("TOP", "LVBM_StatusBarTimer"..(i-1), "BOTTOM", 0, LVBMStatusBars_Designs[LVBM.Options.StatusBarDesign].distance);
		end
	end
end

function LVBMStatusBars_PullTogether()
	for i = 2, LVBM.StatusBarCount do
		if getglobal("LVBM_StatusBarTimer"..i).isUsed and (not getglobal("LVBM_StatusBarTimer"..(i-1)).isUsed) then
			local j = i - 1;
			local barName = getglobal("LVBM_StatusBarTimer"..i).usedBy;
			local timer = LVBM.StatusBarData[barName].timer;
			local elapsed = LVBM.StatusBarData[barName].elapsed;
			local syncedBy = LVBM.StatusBarData[barName].syncedBy;
			local startedBy = LVBM.StatusBarData[barName].startedBy;
			local isRepeating = LVBM.StatusBarData[barName].isRepeating;
			local repetitions = LVBM.StatusBarData[barName].repetitions;
			local bossModID = LVBM.StatusBarData[barName].bossModID;
			getglobal("LVBM_StatusBarTimer"..i):Hide();	
			getglobal("LVBM_StatusBarTimer"..i).isUsed = false;
			getglobal("LVBM_StatusBarTimer"..i).usedBy = "";
			getglobal("LVBM_StatusBarTimer"..i).isRepeating = false;
			getglobal("LVBM_StatusBarTimer"..i).repetitions = 0;
			LVBM.StatusBarData[barName] = nil;
			
			getglobal("LVBM_StatusBarTimer"..j).isUsed = true;
			getglobal("LVBM_StatusBarTimer"..j).usedBy = barName;
			getglobal("LVBM_StatusBarTimer"..j).syncedBy = syncedBy;
			getglobal("LVBM_StatusBarTimer"..j).startedBy = startedBy;
			getglobal("LVBM_StatusBarTimer"..j).isRepeating = isRepeatinge;
			getglobal("LVBM_StatusBarTimer"..j).repetitions = repetitions;
			getglobal("LVBM_StatusBarTimer"..j.."Bar"):SetMinMaxValues(0, timer);
			if type(LVBM_SBT[barName]) == "string" then
				getglobal("LVBM_StatusBarTimer"..j.."BarText"):SetText(LVBM_SBT[barName]);
			else
				getglobal("LVBM_StatusBarTimer"..j.."BarText"):SetText(barName);
			end
			getglobal("LVBM_StatusBarTimer"..j.."BarTimer"):SetText(LVBM.SecondsToTime(timer));
			getglobal("LVBM_StatusBarTimer"..j):Show();
	
			LVBM.StatusBarData[barName] = {
				["elapsed"] = elapsed,
				["timer"] = timer,
				["barId"] = j,
				["syncedBy"] = syncedBy,
				["startedBy"] = startedBy,
				["isRepeating"] = isRepeating,
				["repetitions"] = repetitions,
				["bossModID"] = bossModID,
			};

		end
	end
end

function LVBMStatusBars_Resize()
	LVBM_StatusBarTimerDrag:SetScale(LVBM.Options.StatusBarSize.Scale);
	LVBM_StatusBarTimerDrag:SetWidth(LVBM.Options.StatusBarSize.Width);
	LVBM_StatusBarTimerDragBar:SetWidth(LVBM.Options.StatusBarSize.Width - LVBMStatusBars_Designs[LVBM.Options.StatusBarDesign].widthModifier);
	LVBM_StatusBarTimerDragBarTimer:SetJustifyH("RIGHT");
	LVBM_StatusBarTimerDragBarText:SetWidth(LVBM.Options.StatusBarSize.Width - LVBMStatusBars_Designs[LVBM.Options.StatusBarDesign].textWidthModifier);	
	for i = 1, LVBM.StatusBarCount do
		getglobal("LVBM_StatusBarTimer"..i):SetScale(LVBM.Options.StatusBarSize.Scale);
		getglobal("LVBM_StatusBarTimer"..i):SetWidth(LVBM.Options.StatusBarSize.Width);
		getglobal("LVBM_StatusBarTimer"..i.."Bar"):SetWidth(LVBM.Options.StatusBarSize.Width -  LVBMStatusBars_Designs[LVBM.Options.StatusBarDesign].widthModifier);
		getglobal("LVBM_StatusBarTimer"..i.."BarText"):SetWidth(LVBM.Options.StatusBarSize.Width - LVBMStatusBars_Designs[LVBM.Options.StatusBarDesign].textWidthModifier);		
	end
end

function LVBMStatusBars_CreateNewBar()
	if (LVBM.StatusBarCount + 1) > LVBM.Options.MaxStatusBars then
		return;
	end
	LVBM.StatusBarCount = LVBM.StatusBarCount + 1;
	local newBar = CreateFrame("Frame", "LVBM_StatusBarTimer"..LVBM.StatusBarCount, UIParent, LVBMStatusBars_Designs[LVBM.Options.StatusBarDesign].template);
	newBar:SetScale(LVBM.Options.StatusBarSize.Scale);
	newBar:SetWidth(LVBM.Options.StatusBarSize.Width);
	getglobal(newBar:GetName().."Bar"):SetWidth(LVBM.Options.StatusBarSize.Width - LVBMStatusBars_Designs[LVBM.Options.StatusBarDesign].widthModifier);
	getglobal(newBar:GetName().."BarText"):SetWidth(LVBM.Options.StatusBarSize.Width - LVBMStatusBars_Designs[LVBM.Options.StatusBarDesign].textWidthModifier);
	if LVBM.StatusBarCount == 1 then
		newBar:SetPoint("CENTER", "LVBM_StatusBarTimerDrag", "CENTER", 0, 0);
	else
		if LVBM.Options.StatusBarsFlippedOver then
			newBar:SetPoint("BOTTOM", "LVBM_StatusBarTimer"..(LVBM.StatusBarCount - 1), "TOP", 0, -LVBMStatusBars_Designs[LVBM.Options.StatusBarDesign].distance);
		else
			newBar:SetPoint("TOP", "LVBM_StatusBarTimer"..(LVBM.StatusBarCount - 1), "BOTTOM", 0, LVBMStatusBars_Designs[LVBM.Options.StatusBarDesign].distance);
		end
	end
	LVBMGuiUpdateStatusbars();
	return LVBM.StatusBarCount;
end

function LVBMStatusBars_ChangeDesign(designID)
	local oldDesign = LVBM.Options.StatusBarDesign;
	local oldBarCount = LVBM.StatusBarCount;
	LVBM.Options.StatusBarDesign = designID;
	LVBM.StatusBarCount = 0;
	LVBM.Options.StatusBarColor.r = LVBMStatusBars_Designs[LVBM.Options.StatusBarDesign].color.r;
	LVBM.Options.StatusBarColor.g = LVBMStatusBars_Designs[LVBM.Options.StatusBarDesign].color.g;
	LVBM.Options.StatusBarColor.b = LVBMStatusBars_Designs[LVBM.Options.StatusBarDesign].color.b;
	LVBM.Options.StatusBarColor.a = LVBMStatusBars_Designs[LVBM.Options.StatusBarDesign].color.a;
	LVBM.Options.StatusBarSize.Width = LVBMStatusBars_Designs[LVBM.Options.StatusBarDesign].width;
	LVBM.Options.StatusBarSize.Scale = LVBMStatusBars_Designs[LVBM.Options.StatusBarDesign].scale;
	for index, value in LVBM.StatusBarData do
		LVBM.EndRepeatingStatusBarTimer(index, true);
	end
	for i = 1, oldBarCount do
		getglobal("LVBM_StatusBarTimer"..i):Hide(); --there is no way to delete frames! but a status bar only needs ~5-10kb memory, so a few old hidden bars are no problem :)
		setglobal("LVBM_StatusBarTimer"..i, nil); --wtf? i need to set the old variables to nil before I create a new frame...
		for index, value in LVBMStatusBars_Designs[oldDesign].subFrameNames do
			setglobal("LVBM_StatusBarTimer"..i..value, nil);
		end
		LVBMStatusBars_CreateNewBar();
	end
end